#include <iostream>
using namespace std;
int mas[100000];
bool nab[100000];
int main ()
{
    long N;
    cin>>N;
    short vruska[N-1][2];
    for (long i=0; i<N-1; i++)
    {
        cin>>vruska[i][0]>>vruska[i][1];
        mas[vruska[i][0]]++;
    }
    for (long i=0; i<N-1; i++)
    {
        mas[vruska[i][0]]=mas[vruska[i][0]]+mas[vruska[i][1]];
    }
    long Q;
    cin>>Q;
    short vaprosi[Q];
    for (int i=0; i<Q; i++) cin>>vaprosi[i];
    for (int i=0; i<Q; i++) cout<<mas[vaprosi[i]]<<endl;
    return 0;
}
